Subject: Re: Serial init / BRG

From: Scott Wood <[email-masked]>
Date: Tue, 16 Oct 2007 11:31:31 -0500

Alan Bennett wrote:
>   A few questions:  To use 3 brgs, should I have 1 brg entry and X reg
> values or three brg entries in my device tree? 

The current brg entry describes all 8 BRGs... don't touch it. :-)

> what are the third and fourth reg values of the brg item in the
> device tree. I'll need 3 separate baud rates on the serial lines.
> Should I just add code to initialize the brg's in u-boot or figure
> out how to get the kernel to do it?

No, the kernel should do it.  Are you associating the BRG with the SCC 
in the CMXSCR register, and setting up the pins required by SCC1 and 
SCC4, in either u-boot or your platform code?

> boot sequence
> ===========
>  CPM UART serial mem=e0011a80 pram=e0000000
>  ttyCPM0 at MMIO 0xe0011a80 (irq = 16) is a CPM UART
> 
>  CPM UART serial mem=e0011a00 pram=e0008000
>  CPM uart[1]:init_scc - sup = e0008000
>  ttyCPM1 at MMIO 0xe0011a00 (irq = 40) is a CPM UART
> 
>  CPM UART serial mem=e0011a60 pram=e0008300
>  CPM uart[2]:init_scc - sup = e0008300
>  ttyCPM2 at MMIO 0xe0011a60 (irq = 43) is a CPM UART
> 
> BRG Values after above
> =================
> brgc1: 0x00000000
> brgc2: 0x00000000
> brgc3: 0x00000000
> brgc4: 0x00000000
> brgc5: 0x00000000
> brgc6: 0x00000000
> brgc7: 0x0001004e
> brgc8: 0x00000000

This is expected if you haven't opened the other serial ports yet...  it 
doesn't initialize the brg until then.

-Scott